; ---------------------------------------------------------
;	SRAM setup
; =========================================================
;	(C)2004 t.hara
; ---------------------------------------------------------

	.cpu	300HA

; ---------------------------------------------------------
;	Exports
			.export		InitializeSram

; ---------------------------------------------------------
;	CPU registers
ABWCR		.equ		H'FFFFEC			; area bus width control register
BRCR		.equ		H'FFFFF3			; bus release controller enable register

; ---------------------------------------------------------
			.section	rom, code

; ---------------------------------------------------------
;	SRAM initialize
InitializeSram:
			push.w		R0
			mov.b		#H'FF, R0L			; set output mode to Address out port
			mov.b		R0L, @H'FFFFC0		; 	port1 (A7-A0)
			mov.b		R0L, @H'FFFFC1		;	port2 (A15-A8)
			mov.b		R0L, @H'FFFFC8		;	port5 (A19-A16)
			mov.b		#H'E8, R0L
			mov.b		R0L, @H'FFFFCD		;	port8 (/CS1)
			pop.w		R0
			rts
			.end
