; ---------------------------------------------------------
;	string utility
; =========================================================
;	(C)2004 t.hara
; ---------------------------------------------------------

	.cpu	300HA

; ---------------------------------------------------------
;	Exports
			.export		ConvertHexToNum4
			.export		ConvertNumToHex4

; ---------------------------------------------------------
;	Convert hex character to number (4bit)
;	R0L  16i𐔒lɕϊ R0L ɕԂ
;	sȕ̏ꍇ c_flag 𗧂Ă R0L ɂ͕slԂ
ConvertHexToNum4:
			add.b		#0-"0", R0L
			bcc			ConvertHexToNum4Skip		; check error
			cmp.b		#10, R0L
			bcs			ConvertHexToNum4Skip		; check '0' ... '9'
			add.b		#0-("A"-"0"), R0L			; 'A' ... 'F' ---> 0 ... 5
			bcc			ConvertHexToNum4Skip		; check error
			add			#10, R0L					; 0 ... 5 ---> 10 ... 15
			cmp.b		#16, R0L
			bcs			ConvertHexToNum4Skip		; check 10 ... 15
			add			#0-("a"-"A"), R0L
			cmp.b		#16, R0L
			bcc			ConvertHexToNum4Skip		; check error
			cmp.b		#10, R0L
			xorc.b		#1, CCR
ConvertHexToNum4Skip:
			xorc.b		#1, CCR						; c_flag <= not c_flag
			rts										; c_flag 0: no error, 1: error

; ---------------------------------------------------------
;	Convert number to hex character (4bit)
;	R0L ̉ 4bit ɑΉ 16i R0L ֕Ԃ
ConvertNumToHex4:
			push.l		ER1
			and.b		#H'0F, R0L
			xor.l		ER1, ER1			; ER1 <= 0
			mov.b		R0L, R1L
			add.l		#HexCharacter, ER1
			mov.b		@ER1, R0L
			pop.l		ER1
			rts

; ---------------------------------------------------------
;	Hex characters
HexCharacter:
			.sdata		"0123456789ABCDEF"

			.end
