; ---------------------------------------------------------
;	20x4 LCD module SC2004CS*B Driver
; =========================================================
;	(C)2004 t.hara
; ---------------------------------------------------------

	.import	InitializeLcd		; initialize LCD module
	.import	LcdPutc				; send one character to LCD module
	.import	LcdPuts				; send ZERO terminated string to LCD module
	.import	LcdCommand			; send LCD bulk command
	.import	LcdSetFont			; send font data

; ---------------------------------------------------------
;	LCD Command
LcdClear		.equ	B'00000001
LcdLine0		.equ	B'10000000
LcdLine1		.equ	B'11000000
LcdLine2		.equ	B'10010100
LcdLine3		.equ	B'11010100
LcdHome			.equ	B'00000010
LcdCursorOn		.equ	B'00001111		; display on, cursor on, blink on
LcdCursorOff	.equ	B'00001100		; display on, cursor off, blink off
LcdOff			.equ	B'00001000		; display off, cursor off, blink off
