; ---------------------------------------------------------
;	timing
; =========================================================
;	(C)2004 t.hara
; ---------------------------------------------------------

	.cpu	300HA

; ---------------------------------------------------------
;	Exports
			.export		Wait4ms			; wait 4 millisecond
			.export		Wait2ms			; wait 2 millisecond

; ---------------------------------------------------------
			.section	rom, code

; ---------------------------------------------------------
;	Wait 4 millisecond
Wait4ms:
			push.l		ER0
			mov.l		#H'2000, ER0
Wait4msLoop:
			sub.l		#1, ER0
			bne			Wait4msLoop
			pop.l		ER0
			rts

; ---------------------------------------------------------
;	Wait 2 millisecond
Wait2ms:
			push.l		ER0
			mov.l		#H'1000, ER0
Wait2msLoop:
			sub.l		#1, ER0
			bne			Wait2msLoop
			pop.l		ER0
			rts

			.end
